//
// Small library to access OPenAL EFX extension
//

#include	<stdio.h>
#include	"OpenAlExts.h"
							// Effect objects
LPALGENEFFECTS 		alGenEffects    = NULL;
LPALDELETEEFFECTS 	alDeleteEffects = NULL;
LPALISEFFECT 		alIsEffect      = NULL;
LPALEFFECTI 		alEffecti       = NULL;
LPALEFFECTIV 		alEffectiv      = NULL;
LPALEFFECTF 		alEffectf       = NULL;
LPALEFFECTFV 		alEffectfv      = NULL;
LPALGETEFFECTI 		alGetEffecti    = NULL;
LPALGETEFFECTIV 	alGetEffectiv   = NULL;
LPALGETEFFECTF 		alGetEffectf    = NULL;
LPALGETEFFECTFV 	alGetEffectfv   = NULL;

							//Filter objects
LPALGENFILTERS 		alGenFilters    = NULL;
LPALDELETEFILTERS 	alDeleteFilters = NULL;
LPALISFILTER 		alIsFilter      = NULL;
LPALFILTERI 		alFilteri       = NULL;
LPALFILTERIV 		alFilteriv      = NULL;
LPALFILTERF 		alFilterf       = NULL;
LPALFILTERFV 		alFilterfv      = NULL;
LPALGETFILTERI		alGetFilteri    = NULL;
LPALGETFILTERIV		alGetFilteriv   = NULL;
LPALGETFILTERF		alGetFilterf    = NULL;
LPALGETFILTERFV 	alGetFilterfv   = NULL;

							// Auxiliary slot object
LPALGENAUXILIARYEFFECTSLOTS 	alGenAuxiliaryEffectSlots    = NULL;
LPALDELETEAUXILIARYEFFECTSLOTS 	alDeleteAuxiliaryEffectSlots = NULL;
LPALISAUXILIARYEFFECTSLOT 		alIsAuxiliaryEffectSlot      = NULL;
LPALAUXILIARYEFFECTSLOTI 		alAuxiliaryEffectSloti       = NULL;
LPALAUXILIARYEFFECTSLOTIV 		alAuxiliaryEffectSlotiv      = NULL;
LPALAUXILIARYEFFECTSLOTF 		alAuxiliaryEffectSlotf       = NULL;
LPALAUXILIARYEFFECTSLOTFV 		alAuxiliaryEffectSlotfv      = NULL;
LPALGETAUXILIARYEFFECTSLOTI 	alGetAuxiliaryEffectSloti    = NULL;
LPALGETAUXILIARYEFFECTSLOTIV 	alGetAuxiliaryEffectSlotiv   = NULL;
LPALGETAUXILIARYEFFECTSLOTF 	alGetAuxiliaryEffectSlotf    = NULL;
LPALGETAUXILIARYEFFECTSLOTFV 	alGetAuxiliaryEffectSlotfv   = NULL;

bool	initOpenAlEfx ()
{
	ALCdevice  * device  = NULL;
	ALCcontext * context = NULL;
	bool	     efx     = false;

	context = alcGetCurrentContext ();
	device  = alcGetContextsDevice ( context );

	if ( !alcIsExtensionPresent ( device, (ALCchar*) ALC_EXT_EFX_NAME ) )
		return false;
		
		// Get function pointers
	alGenEffects    = (LPALGENEFFECTS)alGetProcAddress("alGenEffects");
	alDeleteEffects = (LPALDELETEEFFECTS )alGetProcAddress("alDeleteEffects");
	alIsEffect      = (LPALISEFFECT )alGetProcAddress("alIsEffect");
	alEffecti       = (LPALEFFECTI)alGetProcAddress("alEffecti");
	alEffectiv      = (LPALEFFECTIV)alGetProcAddress("alEffectiv");
	alEffectf       = (LPALEFFECTF)alGetProcAddress("alEffectf");
	alEffectfv      = (LPALEFFECTFV)alGetProcAddress("alEffectfv");
	alGetEffecti    = (LPALGETEFFECTI)alGetProcAddress("alGetEffecti");
	alGetEffectiv   = (LPALGETEFFECTIV)alGetProcAddress("alGetEffectiv");
	alGetEffectf    = (LPALGETEFFECTF)alGetProcAddress("alGetEffectf");
	alGetEffectfv   = (LPALGETEFFECTFV)alGetProcAddress("alGetEffectfv");
	alGenFilters    = (LPALGENFILTERS)alGetProcAddress("alGenFilters");
	alDeleteFilters = (LPALDELETEFILTERS)alGetProcAddress("alDeleteFilters");
	alIsFilter      = (LPALISFILTER)alGetProcAddress("alIsFilter");
	alFilteri       = (LPALFILTERI)alGetProcAddress("alFilteri");
	alFilteriv      = (LPALFILTERIV)alGetProcAddress("alFilteriv");
	alFilterf       = (LPALFILTERF)alGetProcAddress("alFilterf");
	alFilterfv      = (LPALFILTERFV)alGetProcAddress("alFilterfv");
	alGetFilteri    = (LPALGETFILTERI )alGetProcAddress("alGetFilteri");
	alGetFilteriv   = (LPALGETFILTERIV )alGetProcAddress("alGetFilteriv");
	alGetFilterf    = (LPALGETFILTERF )alGetProcAddress("alGetFilterf");
	alGetFilterfv   = (LPALGETFILTERFV )alGetProcAddress("alGetFilterfv");
	
	alGenAuxiliaryEffectSlots    = (LPALGENAUXILIARYEFFECTSLOTS)alGetProcAddress("alGenAuxiliaryEffectSlots");
	alDeleteAuxiliaryEffectSlots = (LPALDELETEAUXILIARYEFFECTSLOTS)alGetProcAddress("alDeleteAuxiliaryEffectSlots");
	alIsAuxiliaryEffectSlot      = (LPALISAUXILIARYEFFECTSLOT)alGetProcAddress("alIsAuxiliaryEffectSlot");
	alAuxiliaryEffectSloti       = (LPALAUXILIARYEFFECTSLOTI)alGetProcAddress("alAuxiliaryEffectSloti");
	alAuxiliaryEffectSlotiv      = (LPALAUXILIARYEFFECTSLOTIV)alGetProcAddress("alAuxiliaryEffectSlotiv");
	alAuxiliaryEffectSlotf       = (LPALAUXILIARYEFFECTSLOTF)alGetProcAddress("alAuxiliaryEffectSlotf");
	alAuxiliaryEffectSlotfv      = (LPALAUXILIARYEFFECTSLOTFV)alGetProcAddress("alAuxiliaryEffectSlotfv");
	alGetAuxiliaryEffectSloti    = (LPALGETAUXILIARYEFFECTSLOTI)alGetProcAddress("alGetAuxiliaryEffectSloti");
	alGetAuxiliaryEffectSlotiv   = (LPALGETAUXILIARYEFFECTSLOTIV)alGetProcAddress("alGetAuxiliaryEffectSlotiv");
	alGetAuxiliaryEffectSlotf    = (LPALGETAUXILIARYEFFECTSLOTF)alGetProcAddress("alGetAuxiliaryEffectSlotf");
	alGetAuxiliaryEffectSlotfv   = (LPALGETAUXILIARYEFFECTSLOTFV)alGetProcAddress("alGetAuxiliaryEffectSlotfv");

printf ( "EFX inited !\n" );

	return alGenEffects &&	alDeleteEffects && alIsEffect && alEffecti && alEffectiv &&	alEffectf &&
		   alEffectfv && alGetEffecti && alGetEffectiv && alGetEffectf && alGetEffectfv &&	alGenFilters &&
		   alDeleteFilters && alIsFilter && alFilteri && alFilteriv &&	alFilterf && alFilterfv &&
		   alGetFilteri &&	alGetFilteriv && alGetFilterf && alGetFilterfv && alGenAuxiliaryEffectSlots &&
		   alDeleteAuxiliaryEffectSlots &&	alIsAuxiliaryEffectSlot && alAuxiliaryEffectSloti &&
		   alAuxiliaryEffectSlotiv && alAuxiliaryEffectSlotf && alAuxiliaryEffectSlotfv &&
		   alGetAuxiliaryEffectSloti && alGetAuxiliaryEffectSlotiv && alGetAuxiliaryEffectSlotf &&
		   alGetAuxiliaryEffectSlotfv;
}

