//
// Class to represent filter in OpenAL 1.1
//

#ifndef	__OPENAL_FILTER__
#define	__OPENAL_FILTER__

#include	<al.h>
#include	<alc.h>
#include	<efx.h>

class	OpenAlFilter
{
protected:
	ALuint	id;
	ALuint	type;
	bool	ok;
	
public:
	OpenAlFilter  ( ALuint theType = AL_FILTER_NULL );
	~OpenAlFilter ();
	
	bool	isOk () const
	{
		return ok;
	}
	
	ALuint	getId () const
	{
		return id;
	}
};

class	OpenAlLowPassFilter : public OpenAlFilter
{
	float	gain;
	float	gainHf;
public:
	OpenAlLowPassFilter ( float theGain, float theHfGain );
};

class	OpenAlHighPassFilter : public OpenAlFilter
{
	float	gain;
	float	gainLf;
public:
	OpenAlHighPassFilter ( float theGain, float theLfGain );
};

class	OpenAlBandPassFilter : public OpenAlFilter
{
	float	gain;
	float	gainLf;
	float	gainHf;
public:
	OpenAlBandPassFilter ( float theGain, float theLfGain, float theHfGain );
};

#endif
