//
// Class to represent filter in OpenAL 1.1
//

#include	"OpenAlSlot.h"
#include	"OpenAlExts.h"
#include	"OpenALEffect.h"

OpenAlSlot :: OpenAlSlot  ()
{
	alGenAuxiliaryEffectSlots ( 1, &id );
	
	effect = NULL;
	gain   = 1.0f;
	no     = 0;
	ok     = alGetError () == AL_NO_ERROR;
}

OpenAlSlot :: ~OpenAlSlot ()
{
	alDeleteAuxiliaryEffectSlots ( 1, &id );
}

bool	OpenAlSlot :: bindToNo ( int n )
{
	no = n;
	
	return true;
}

bool	OpenAlSlot :: attachEffect ( OpenAlEffect * theEffect )
{
	alAuxiliaryEffectSloti ( id, AL_EFFECTSLOT_EFFECT, theEffect -> getId () );
	
	if ( alGetError () != AL_NO_ERROR )
		return false;
		
	effect = theEffect;
	
	return true;
}

bool	OpenAlSlot :: detachEffect ()
{
	alAuxiliaryEffectSloti ( id, AL_EFFECTSLOT_EFFECT, 0 );
	
	effect = NULL;
	
	return alGetError () == AL_NO_ERROR;
}

void	OpenAlSlot :: setGain ( float g )
{
	alAuxiliaryEffectSlotf ( id, AL_EFFECTSLOT_GAIN, gain = g );
}
