//
// Class to represent filter in OpenAL 1.1
//

#ifndef	__OPENAL_SLOT__
#define	__OPENAL_SLOT__

#include	<al.h>
#include	<alc.h>
#include	<efx.h>

class	OpenAlEffect;

class	OpenAlSlot
{
protected:
	ALuint	       id;
	bool	       ok;
	float	       gain;
	int		   	   no;						// openAl slot, by default 0
	OpenAlEffect * effect;
	
public:
	OpenAlSlot  ();
	~OpenAlSlot ();
	
	bool	isOk () const
	{
		return ok;
	}
	
	ALuint	getId () const
	{
		return id;
	}
	
	OpenAlEffect * getEffect () const
	{
		return effect;
	}
	
	int	getNo () const
	{
		return no;
	}
	
	bool	bindToNo     ( int n );
	bool	attachEffect ( OpenAlEffect * effect );
	bool	detachEffect ();
	void	setGain      ( float g );
};

#endif
