//
// Sound data class for OpenAL
//

#ifndef	__SOUND_DATA__
#define	__SOUND_DATA__

#include	<stdio.h>
#include	"TypeDefs.h"

class	Data;

class	SoundData
{
protected:
	Data  * data;
	FILE  * fp;
	int		numChannels;
	int		frequency;
	int		bitsPerSample;
	bool	ok;

public:
	SoundData ( Data * theData );
	SoundData ( const char * theFileName );
	virtual	~SoundData ();


	int	getNumChannels () const
	{
		return numChannels;
	}

	int	getFrequency () const
	{
		return frequency;
	}

	int	getBitsPerSample () const
	{
		return bitsPerSample;
	}
	
	virtual	bool	isOk () const;
	
											// get size in bytes of unpacked audio data
	virtual	size_t	getSize () const = 0;

											// fill buffer with next audio data
	virtual	int	read ( byte * buf, int size = -1 ) = 0;

											// fill buffer with next audio data as mono
	virtual	int	readMono ( byte * buf, int size = -1 ) = 0;

											// position in sound (in seconds)
	virtual	bool	seek ( float time ) = 0;
	
											// whether we're at end of sound data
	virtual	bool	atEnd () const;
};

#endif
