//
// Example of using OpenAL wrapper classes
//
// Author: Alex V. Boreskoff <steps3d@narod.ru>, <alexboreskoff@mtu-net.ru>
//

#include	<stdio.h>
#include	<stdlib.h>

#ifndef	_WIN32
    #include	"kbhit.h"
#else
    #include	<windows.h>
    #include	<conio.h>
    #include	<process.h>
    
    #define	initKeyboard()
    #define	closeKeyboard()
#endif

#include	"OpenAlContext.h"
#include	"OpenAlFilter.h"
#include	"OpenAlEffect.h"
#include	"OpenAlSlot.h"
#include	"ReverbEffect.h"
#include	"SoundSource.h"
#include	"SoundData.h"

int main ()
{
//ALuint type = AL_EFFECT_CHORUS;
//ALuint type = AL_EFFECT_DISTORTION;
//ALuint type = AL_EFFECT_ECHO;
//ALuint type = AL_EFFECT_FLANGER;
//ALuint type = AL_EFFECT_FREQUENCY_SHIFTER;
//ALuint type = AL_EFFECT_VOCAL_MORPHER;
//ALuint type = AL_EFFECT_PITCH_SHIFTER;
//ALuint type = AL_EFFECT_RING_MODULATOR;
//ALuint type = AL_EFFECT_AUTOWAH;
//ALuint type = AL_EFFECT_COMPRESSOR;
//ALuint type = AL_EFFECT_EQUALIZER;
ALuint type = AL_EFFECT_REVERB;
//ALuint type = AL_EFFECT_EAXREVERB; 

	OpenAlContext	context;
	SoundData     * data = OpenAlContext :: open ( "wavdata/footsteps.wav" );
	
	if ( data == NULL )
		return 1;
		
	initKeyboard ();
	
	bool		  attached = true;
	SoundSource * sound = new SoundSource ( data, true );
	OpenAlEffect  effect ( type );
	OpenAlSlot	  slot;

	if ( !effect.isOk () )
		printf ( "Effect failure !\n" );
		
	slot.attachEffect ( &effect );
	sound -> enableAuxSlot ( &slot );
	sound -> play          ();

	printf ( "Effect: %s\n", attached ? "on" : "off" );

	for ( ; ; )
	{
		sound -> update ();
	
		if ( kbhit () )
		{
			int	ch = getche ();
			
			if ( ch == 27 )
				break;
				
			attached = !attached;
			
			if ( attached )
				sound -> enableAuxSlot  ( &slot );
			else
				sound -> disableAuxSlot ( &slot );
				
			printf ( "Effect: %s\n", attached ? "on" : "off" );
		}

											// make some delay
		int	i, j;
		
		for ( i = j = 0; i < 1000; i++ )
		    j += i*j + 1;	    
	}
	
	closeKeyboard ();
	
	return 0;
}
